<template>
  <v-row justify="center">
    <v-col cols="12" class="d-flex align-center justify-space-between">
      <h1>Liste des code promos</h1>
      <Toolbar :handle-add="addHandler" />
    </v-col>

    <v-col cols="12">
      <v-text-field v-model="search" placeholder="Recherche par code"></v-text-field>

      <v-data-table
        v-model="selected"
        :headers="headers"
        :items="filteredItems"
        :loading="isLoading"
        :loading-text="$t('Chargement...')"
        class="elevation-1"
        item-key="@id"
        @update:options="onUpdateOptions"
      >
        <template v-slot:item.sold="{ item }">{{item.isPercent ? item.sold + "%" : item.sold + "€"}}</template>

        <template v-slot:item.isActive="{ item }">
          <v-btn
            :color="item.isActive ? 'green' : 'red' "
            @click="toggleActivation(item)"
            class="mb-2 mb-sm-0 mr-2"
            style="color: white;"
          >
            <v-icon style="text-decoration: none;">{{ item.isActive ? "mdi-check" : "mdi-close" }}</v-icon>
          </v-btn>
        </template>

        <template v-slot:item.editer="{ item }">
          <router-link
            style="text-decoration: none; margin-right: 5px;"
            :to="{ name: 'PromoCodeUpdate', params: {id: item.id} }"
          >
            <v-icon style="text-decoration: none;">mdi-pencil</v-icon>
          </router-link>
        </template>
      </v-data-table>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import ListMixin from "../../../mixins/ListMixin";
import Toolbar from "../../../components/Toolbar";

export default {
  name: "PromoCodeList",
  servicePrefix: "PromoCode",
  mixins: [ListMixin],
  components: {
    Toolbar
  },
  data() {
    return {
      headers: [
        { text: "Code", value: "code", sortable: false },
        { text: "Réduction", value: "sold", sortable: false },
        { text: "Commentaire", value: "comment", sortable: false },
        { text: "Code activé ?", value: "isActive", sortable: false },
        { text: "Editer", value: "editer", sortable: false }
      ],
      selected: [],
      search: "",
      loaded: false
    };
  },
  computed: {
    ...mapFields("promoCode", {
      deletedItem: "deleted",
      error: "error",
      isLoading: "isLoading",
      resetList: "resetList",
      totalItems: "totalItems",
      view: "view"
    }),
    ...mapFields("admin", ["company", "companyFound"]),
    ...mapFields("user", ["userInfos", "loggedIn"]),
    ...mapFields("adminPromoCode", {
      items: "listPromoCode"
    }),
    filteredItems() {
      return this.items.filter(item => {
        return item.code.toLowerCase().includes(this.search.toLowerCase());
      });
    }
  },
  created() {
    if (this.userInfos) {
      this.getProfile(this.userInfos.id);
      this.getListCodePromo();
      this.loaded = true;
    }
  },
  watch: {
    userInfos(newData) {
      if (newData) {
        this.getCompany(newData.company["@id"].split("/")[2]);
      }
    }
  },
  methods: {
    ...mapActions("promoCode", {
      getPage: "fetchAll",
      deleteItem: "del"
    }),
    ...mapActions("admin", ["getCompany"]),
    ...mapActions("user", ["getProfile"]),
    ...mapActions("adminPromoCode", ["setIsActive", "getListCodePromo"]),
    toggleActivation(item) {
      this.setIsActive(item);
    }
  }
};
</script>
